<template>
  <form
    class="bg-primary-500 bg-opacity-30 rounded border border-primary-600 flex flex-col p-4"
    @submit.stop.prevent="updatePassword"
  >
    <div
      class="flex flex-col justify-center space-y-2 border border-blue-800 rounded bg-blue-400 bg-opacity-40 p-2 items-center"
    >
      <h2 class="text-xl">Atualizar senha</h2>
      <div class="flex flex-row gap-2 items-center justify-between w-full">
        <h2>Nova senha</h2>
        <BaseInput
          v-model="password.first"
          required
          type="password"
          class="w-36"
          maxlength="10"
          minlength="5"
        />
      </div>
      <div class="flex flex-row gap-2 items-center justify-between w-full">
        <h2>Repetir senha</h2>
        <BaseInput
          v-model="password.second"
          required
          type="password"
          class="w-36"
          maxlength="10"
          minlength="5"
        />
      </div>
      <BaseButton
        label="Atualizar"
        class="border border-blue-800 bg-primary-900 bg-opacity-40 rounded"
      >
        <RefreshIcon class="h-5 w-5" />
      </BaseButton>
    </div>
  </form>
</template>

<script>
import { RefreshIcon } from '@vue-hero-icons/outline'
import { getAxiosHeaders } from '~/utils/utils'
import BaseButton from '~/components/ui/BaseButton.vue'
import BaseInput from '~/components/ui/BaseInput.vue'
export default {
  name: 'UpdatePasswordView',
  components: {
    RefreshIcon,
    BaseButton,
    BaseInput,
  },
  data() {
    return {
      password: {
        first: '',
        second: '',
      },
    }
  },
  methods: {
    async updatePassword() {
      if (this.password.first !== this.password.second) {
        return this.$toast.info('Senhas não coincidem.', {
          closeOnSwipe: true,
          duration: 3000,
        })
      }
      try {
        await this.$axios
          .$put(
            `updateUser/${this.$auth.user.id()}`,
            {
              newPassword: this.password.first,
            },
            getAxiosHeaders(this.$auth)
          )
          .then((response) => {
            if (response.status.is_error) {
              return this.$toast.error('Não foi possível atualizar a senha.', {
                closeOnSwipe: true,
                duration: 3000,
              })
            }
            return this.$toast.success('Senha atualizada!', {
              closeOnSwipe: true,
              duration: 2000,
            })
          })
      } catch (error) {
        // eslint-disable-next-line no-console
        console.warn(error)
        this.$toast.error('Ocorreu um erro inesperado...', {
          closeOnSwipe: true,
          duration: 2000,
        })
      }
    },
  },
}
</script>
